package along.prj.ui;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.filechooser.FileNameExtensionFilter;

import com.sun.java.swing.plaf.windows.WindowsLookAndFeel;

import along.prj.read.ReadTexts;

public class AppUi extends JFrame implements ActionListener{

	private static final long serialVersionUID = 1L;
	private JTextArea mainArea;
	private JButton execButton,srcButton,desButton;
	private JFileChooser readChooser,writeChooser;
	private File srcDir=null,desFile=null;
	private JRadioButton fileTypeRadio1,fileTypeRadio2,fileTypeRadio3,fileTypeRadio4,fileTypeRadio5,fileTypeRadioOth;
	private JRadioButton readCharSetDef,readCharSet1,readCharSet2,readCharSet3,readCharSet4,readCharSetOth;
	private JRadioButton writeCharSetDef,writeCharSet1,writeCharSet2,writeCharSet3,writeCharSet4,writeCharSetOth;
	private ButtonGroup fileTypeGroup,readCharSetGroup,writeCharSetGroup;
	private String fileType = null,readCharsetName = null,writeCharsetName = null;
	private JTextField othFileType,othReadCharset,othWriteCharset;

	public  AppUi() {
		init();

		addToMainPane();

		try {
			UIManager.setLookAndFeel(new WindowsLookAndFeel());
		} catch (UnsupportedLookAndFeelException e) {
			e.printStackTrace();
		}
		SwingUtilities.updateComponentTreeUI(this);
		SwingUtilities.updateComponentTreeUI(readChooser);
		SwingUtilities.updateComponentTreeUI(writeChooser);

		setSize(800,600);
		int width = Toolkit.getDefaultToolkit().getScreenSize().width;
		int height = Toolkit.getDefaultToolkit().getScreenSize().height;
		setLocation(width/2-400, height/2-300);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setIconImage(this.getToolkit().getImage(AppUi.class.getResource("img/images41.png")));
		setVisible(true);
	}

	private void addToMainPane() {
		String useTip1 = "ͬ͵ıļϲһtxtļģʹʱҪע¼";
		String useTip2 = "ļͣļֻһЩıͣļͣ粻wordļ\n" +
				"ļȡַ:ҪȡļԺֱ洢ģӦͬıȡ\n" +
				"\tɵļпܻ룬޷ĶȷϢ\n" +
				"ļ洢ַͿԸϲˣûʲô\n" +
				"\tҪע⣬ļȡ뻹Ǵ洢룬Ӧϵͳֵ֧ı룬\n" +
				"\tԼдһƣˣʹг\n" +
				"ļȡĿ¼ϣĸļȡıļѡǸļ\n" +
				"\tҲֱѡһıļļǰĿ¼µĿļ\n" +
				"ļĿ¼ϣɵµıļŵѡǸļ\n" +
				"\tҲֱѡһtxtļɵļḲѡtxtļ\n" +
				"ִУϲ󣬾ͿԵִУóʼˣע⣬\n" +
				"\tĲ⣬򽫻ʾ밴ʾ޸ģȻٵִУ";
		JPanel topJPanel = new JPanel(new BorderLayout());
		JTextArea useTipJLabel1 = new JTextArea(useTip1);
		useTipJLabel1.setFont(new Font("", Font.BOLD, 17));
		useTipJLabel1.setEditable(false);
		JTextArea useTipJLabel2 = new JTextArea(useTip2);
		useTipJLabel2.setFont(new Font("", Font.PLAIN, 15));
		useTipJLabel2.setEditable(false);
		topJPanel.add(useTipJLabel1,BorderLayout.NORTH);
		topJPanel.add(useTipJLabel2);
		add(topJPanel,BorderLayout.NORTH);

		JScrollPane jScrollPane = new JScrollPane(mainArea);
		add(jScrollPane);

		JPanel bottomJPanel = new JPanel(new GridLayout(4, 1));

		JPanel bottomJPanel_1 = new JPanel();
		JLabel boxTip = new JLabel("ıļ");
		bottomJPanel_1.add(boxTip);
		fileTypeGroup.add(fileTypeRadio1);
		fileTypeGroup.add(fileTypeRadio2);
		fileTypeGroup.add(fileTypeRadio3);
		fileTypeGroup.add(fileTypeRadio4);
		fileTypeGroup.add(fileTypeRadio5);
		fileTypeGroup.add(fileTypeRadioOth);
		bottomJPanel_1.add(fileTypeRadio1);
		bottomJPanel_1.add(fileTypeRadio2);
		bottomJPanel_1.add(fileTypeRadio3);
		bottomJPanel_1.add(fileTypeRadio4);
		bottomJPanel_1.add(fileTypeRadio5);
		bottomJPanel_1.add(fileTypeRadioOth);
		bottomJPanel_1.add(othFileType);
		bottomJPanel.add(bottomJPanel_1);

		JPanel bottomJPanel_2 = new JPanel();
		JLabel readCharSetTip = new JLabel("ѡȡļõַ");
		bottomJPanel_2.add(readCharSetTip);
		readCharSetGroup.add(readCharSetDef);
		readCharSetGroup.add(readCharSet1);
		readCharSetGroup.add(readCharSet2);
		readCharSetGroup.add(readCharSet3);
		readCharSetGroup.add(readCharSet4);
		readCharSetGroup.add(readCharSetOth);
		bottomJPanel_2.add(readCharSetDef);
		bottomJPanel_2.add(readCharSet1);
		bottomJPanel_2.add(readCharSet2);
		bottomJPanel_2.add(readCharSet3);
		bottomJPanel_2.add(readCharSet4);
		bottomJPanel_2.add(readCharSetOth);
		bottomJPanel_2.add(othReadCharset);
		bottomJPanel.add(bottomJPanel_2);

		JPanel bottomJPanel_3 = new JPanel();
		JLabel writeCharSetTip = new JLabel("ѡ洢ļõַ");
		bottomJPanel_3.add(writeCharSetTip);
		writeCharSetGroup.add(writeCharSetDef);
		writeCharSetGroup.add(writeCharSet1);
		writeCharSetGroup.add(writeCharSet2);
		writeCharSetGroup.add(writeCharSet3);
		writeCharSetGroup.add(writeCharSet4);
		writeCharSetGroup.add(writeCharSetOth);
		bottomJPanel_3.add(writeCharSetDef);
		bottomJPanel_3.add(writeCharSet1);
		bottomJPanel_3.add(writeCharSet2);
		bottomJPanel_3.add(writeCharSet3);
		bottomJPanel_3.add(writeCharSet4);
		bottomJPanel_3.add(writeCharSetOth);
		bottomJPanel_3.add(othWriteCharset);
		bottomJPanel.add(bottomJPanel_3);

		JPanel bottomJPanel_4 = new JPanel();
		bottomJPanel_4.add(srcButton);
		bottomJPanel_4.add(desButton);
		bottomJPanel_4.add(execButton);
		bottomJPanel.add(bottomJPanel_4);


		add(bottomJPanel,BorderLayout.SOUTH);
	}

	private void init() {
		Font font = new Font("", Font.PLAIN, 15);

		mainArea = new JTextArea(8,20);
		mainArea.setEditable(false);
		execButton = new JButton("ִ");
		execButton.addActionListener(this);
		srcButton = new JButton("ļȡĿ¼");
		srcButton.addActionListener(this);
		desButton = new JButton("ļĿ¼");
		desButton.addActionListener(this);

		readChooser = new JFileChooser();
		readChooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		readChooser.setFileHidingEnabled(true);
		readChooser.setAcceptAllFileFilterUsed(false);
		readChooser.setDialogTitle("ѡļԴĿ¼");

		writeChooser = new JFileChooser();
		writeChooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		writeChooser.setFileHidingEnabled(true);
		writeChooser.setAcceptAllFileFilterUsed(false);
		writeChooser.setDialogTitle("ѡļĿ¼");
		FileNameExtensionFilter filter = new FileNameExtensionFilter( "txt ļ","txt");
		writeChooser.setFileFilter(filter);


		fileTypeGroup = new ButtonGroup();
		fileTypeRadio1 = new JRadioButton("xml",true);
		fileTypeRadio1.setActionCommand("xml");
		fileTypeRadio1.addActionListener(this);
		fileTypeRadio2 = new JRadioButton("java");
		fileTypeRadio2.setActionCommand("java");
		fileTypeRadio2.addActionListener(this);
		fileTypeRadio3 = new JRadioButton("txt");
		fileTypeRadio3.setActionCommand("txt");
		fileTypeRadio3.addActionListener(this);
		fileTypeRadio4 = new JRadioButton("ini");
		fileTypeRadio4.setActionCommand("ini");
		fileTypeRadio4.addActionListener(this);
		fileTypeRadio5 = new JRadioButton("html");
		fileTypeRadio5.setActionCommand("html");
		fileTypeRadio5.addActionListener(this);
		fileTypeRadioOth = new JRadioButton("");
		fileTypeRadioOth.setActionCommand("other");
		fileTypeRadioOth.addActionListener(this);
		othFileType = new JTextField(15);
		othFileType.setFont(font);
		othFileType.setEnabled(false);

		readCharSetGroup = new ButtonGroup();
		readCharSetDef =new JRadioButton("ϵͳĬ",true);
		readCharSetDef.setActionCommand("default");
		readCharSetDef.addActionListener(this);
		readCharSet1 =new JRadioButton("ASCII");
		readCharSet1.setActionCommand("ASCII");
		readCharSet1.addActionListener(this);
		readCharSet2 =new JRadioButton("GBK");
		readCharSet2.setActionCommand("GBK");
		readCharSet2.addActionListener(this);
		readCharSet3 =new JRadioButton("UTF-8");
		readCharSet3.setActionCommand("UTF-8");
		readCharSet3.addActionListener(this);
		readCharSet4 =new JRadioButton("UNICODE");
		readCharSet4.setActionCommand("UNICODE");
		readCharSet4.addActionListener(this);
		readCharSetOth = new JRadioButton("");
		readCharSetOth.setActionCommand("other");
		readCharSetOth.addActionListener(this);
		othReadCharset = new JTextField(15);
		othReadCharset.setFont(font);
		othReadCharset.setEnabled(false);

		writeCharSetGroup = new ButtonGroup();
		writeCharSetDef =new JRadioButton("ϵͳĬ",true);
		writeCharSetDef.setActionCommand("default");
		writeCharSetDef.addActionListener(this);
		writeCharSet1 =new JRadioButton("ASCII");
		writeCharSet1.setActionCommand("ASCII");
		writeCharSet1.addActionListener(this);
		writeCharSet2 =new JRadioButton("GBK");
		writeCharSet2.setActionCommand("GBK");
		writeCharSet2.addActionListener(this);
		writeCharSet3 =new JRadioButton("UTF-8");
		writeCharSet3.setActionCommand("UTF-8");
		writeCharSet3.addActionListener(this);
		writeCharSet4 =new JRadioButton("UNICODE");
		writeCharSet4.setActionCommand("UNICODE");
		writeCharSet4.addActionListener(this);
		writeCharSetOth = new JRadioButton("");
		writeCharSetOth.setActionCommand("other");
		writeCharSetOth.addActionListener(this);
		othWriteCharset = new JTextField(15);
		othWriteCharset.setFont(font);
		othWriteCharset.setEnabled(false);

	}

	public static void main(String[] args) {
		new AppUi();
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==execButton){
			try {
				fileType = fileTypeGroup.getSelection().getActionCommand();
				readCharsetName = readCharSetGroup.getSelection().getActionCommand();
				writeCharsetName = writeCharSetGroup.getSelection().getActionCommand();
				if(fileType.equals("other")){
					fileType = othFileType.getText();
					if("".equals(fileType.trim())){
						JOptionPane.showMessageDialog(this, "ļͲΪգո񣩣");
						othFileType.requestFocusInWindow();
						return;
					}
				}
				if(readCharsetName.equals("other")){
					readCharsetName = othReadCharset.getText();
					if("".equals(readCharsetName.trim())){
						JOptionPane.showMessageDialog(this, "ַ벻Ϊգո񣩣");
						othReadCharset.requestFocusInWindow();
						return;
					}
				}
				if(writeCharsetName.equals("other")){
					writeCharsetName = othWriteCharset.getText();
					if("".equals(writeCharsetName.trim())){
						JOptionPane.showMessageDialog(this, "ַ벻Ϊգո񣩣");
						othWriteCharset.requestFocusInWindow();
						return;
					}
				}
				if(srcDir==null||desFile==null){
					JOptionPane.showMessageDialog(this, "㻹ûѡԴĿ¼Ŀ¼", "󣡣", JOptionPane.ERROR_MESSAGE);
					return;
				}
				if(!srcDir.exists()){
					JOptionPane.showMessageDialog(this, "ԴĿ¼ڣѡԴĿ¼", "󣡣", JOptionPane.ERROR_MESSAGE);
					return;
				}
				if(srcDir.isFile()){
					String parent = srcDir.getParent();
					srcDir = new File(parent);
				}
				if(!desFile.exists()){
					JOptionPane.showMessageDialog(this, "Ŀ¼ڣѡĿ¼", "󣡣", JOptionPane.ERROR_MESSAGE);
					return;
				}
				if(desFile.isDirectory()){
					String des = desFile.getAbsolutePath()+File.separator+"des.txt";
					desFile = new File(des);
					if(desFile.exists()){
						int message = JOptionPane.showConfirmDialog(this, "ѡĿ¼ѴΪ "+desFile.getName()+" ļҪ", "ʾ", JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
						if(message==2)
							return;
					}else
						desFile.createNewFile();
				}else if(desFile.isFile()){
					String fileName = desFile.getName();
					if(!fileName.endsWith("txt")){
						JOptionPane.showMessageDialog(this, "Ҫǵļһtxtļѡһtxtļ", "", JOptionPane.ERROR_MESSAGE);
						return;
					}
					int message = JOptionPane.showConfirmDialog(this, "ȷʵҪıļ "+fileName+" ", "ʾ", JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE);
					if(message == 2)
						return;
				}
				mainArea.append("ʼɨԴĿ¼"+srcDir.getName()+" µıļ\n");
				int count = ReadTexts.init(srcDir, desFile,fileType,readCharsetName,writeCharsetName);
				mainArea.append("ɣɨ赽"+count+""+fileType+"Դļѽɨ赽Դļ洢Ŀļ"+desFile.getAbsolutePath()+"\n");
				srcDir = null;
				desFile = null;
				JOptionPane.showMessageDialog(this, "ɣ");
			} catch (Exception e1) {
				e1.printStackTrace();
				JOptionPane.showMessageDialog(this, "ʧܣԭ"+e1.getMessage());
			}
			return;
		}
		if(e.getSource()==srcButton){
			fileType = fileTypeGroup.getSelection().getActionCommand();
			if(fileType.equals("other")){
				fileType = othFileType.getText();
				if("".equals(fileType.trim())){
					JOptionPane.showMessageDialog(this, "ļͲΪգո񣩣");
					othFileType.requestFocusInWindow();
					return;
				}
			}
			FileNameExtensionFilter filter = new FileNameExtensionFilter( fileType + " ļ",fileType);
			readChooser.setFileFilter(filter);
			if(readChooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION){
				File file = readChooser.getSelectedFile();
				srcDir = file;
			}
			readChooser.removeChoosableFileFilter(filter);
			return;
		}
		if(e.getSource()==desButton){
			if(writeChooser.showSaveDialog(this)==JFileChooser.APPROVE_OPTION){
				File file = writeChooser.getSelectedFile();
				desFile = file;
			}
			return;
		}
		{	
			if(fileTypeGroup.getSelection().getActionCommand().equals("other")){
				othFileType.setEnabled(true);
			}
			else
				othFileType.setEnabled(false);
			if(readCharSetGroup.getSelection().getActionCommand().equals("other")){
				othReadCharset.setEnabled(true);
			}
			else
				othReadCharset.setEnabled(false);
			if(writeCharSetGroup.getSelection().getActionCommand().equals("other")){
				othWriteCharset.setEnabled(true);
			}
			else
				othWriteCharset.setEnabled(false);
		}
	}
}

